package com.ruixuan.isc.mapper;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ruixuan.isc.entity.KuaishouItemCollectSampleExpress;
import com.ruixuan.isc.entity.KuaishouItemCollectSampleLog;
import com.ruixuan.isc.entity.KuaishouItemCollectSamples;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;


/**
 * 【请填写功能名称】Mapper接口
 *
 * @author ruoyi
 * @date 2023-02-08
 */
public interface KuaishouItemCollectSamplesMapper {
    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    public KuaishouItemCollectSamples selectKuaishouItemCollectSamplesById(Long id);

    /**
     * 查询【请填写功能名称】列表
     *
     * @param requestMap 【请填写功能名称】
     * @return 【请填写功能名称】集合
     */
    public List<KuaishouItemCollectSamples> selectKuaishouItemCollectSamplesList(Map<String, Object> requestMap);

    /**
     * 新增【请填写功能名称】
     *
     * @param kuaishouItemCollectSamples 【请填写功能名称】
     * @return 结果
     */
    public int insertKuaishouItemCollectSamples(KuaishouItemCollectSamples kuaishouItemCollectSamples);

    /**
     * 修改【请填写功能名称】
     *
     * @param kuaishouItemCollectSamples 【请填写功能名称】
     * @return 结果
     */
    public int updateKuaishouItemCollectSamples(KuaishouItemCollectSamples kuaishouItemCollectSamples);

    /**
     * 删除【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    public int deleteKuaishouItemCollectSamplesById(Long id);

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteKuaishouItemCollectSamplesByIds(Long[] ids);

    List<JSONObject> getItemList(@Param("itemIds") JSONArray itemIds);

    List<JSONObject> promoterList(@Param("ids") JSONArray ids);

    Integer check(@Param("itemId") Long itemId, @Param("promoterId") String promoterId);

    void batchAdd(@Param(value = "adds") List<KuaishouItemCollectSamples> adds);

    void updateByNum(KuaishouItemCollectSamples updateSample);

    void replaceExpress(KuaishouItemCollectSampleExpress express);

    KuaishouItemCollectSampleExpress getExpress(@Param("courierNumber") String courierNumber);

    Integer getStatusByCourierNumbe(@Param("nu") String nu);

    JSONObject courierNumberInfo(String courierNumber);

    void insertLog(KuaishouItemCollectSampleLog sampleLog);

    void batchAddLogs(@Param(value = "adds") List<KuaishouItemCollectSampleLog> logs);

    List<KuaishouItemCollectSampleLog> getLogList(@Param("sampleId") Long id);

    void cleanLogs(@Param("sampleId") Long sampleId, @Param("status") Integer status);

    List<JSONObject> exportCollectSamples(Map<String, Object> requestMap);

    JSONObject getCollectSampleInfo(@Param("itemId") Long itemId);

    JSONObject promoterInfo(@Param("promoterId") String promoterId);

    Long getItemIdById(@Param("id") Long id);

    Integer getSampleCountByUserId(@Param("userList") List<Long> userList, @Param("userType") Integer userType, @Param("status") Integer status);

    JSONObject queryTheNumberOfCompletedJobs(@Param("promoterIds") List<String> promoterIds, @Param("startDate") String startDate,
                                             @Param("endDate") String endDate, @Param("mediaId") String mediaId);

    List<JSONObject> selectPromoterInfo(@Param("map") Map<String, String> map);

    List<Long> getItemIdsByCreateId(@Param("userList") List<Long> userList,@Param("mediaId") String mediaId);

    List<JSONObject> queryProductList(Map<String, Object> map);

    void batchProcess(@Param("ids") JSONArray ids, @Param("status") Integer status);

    List<KuaishouItemCollectSamples> getListByPromoterId(@Param("promoterId") String promoterId, @Param("userId") Long userId);

    Integer checkByRelateIdAndPromoterId(@Param("relateId") Long relateId, @Param("promoterId") String promoterId);

    List<Long> getAccordWithOrderQuantityList();

    void updateByIds(@Param("ids") List<Long> ids);
}

